<?php
try {
    require_once $oPlugin->cFrontendPfad . "hooks/settings.php";
    $io = $args_arr['io'];

    function getAvailableDhlServices($zip, $startdate = null)
    {
        $excludedDays = array();

        $dayMapping = [
            "SO" => 0,
            "MO" => 1,
            "DI" => 2,
            "MI" => 3,
            "DO" => 4,
            "FR" => 5,
            "SA" => 6
        ];

        $currentDate = new DateTime();
        $deliveryDate = new DateTime();
        $_SESSION['wunschtag_selected']="0";
        $_SESSION['wunschzeit_selected']="0";

        $tmpPlugin = Shop::DB()->selectSingleRow("tplugin", "cPluginID", "jtl_dhlwunschpaket");
        $oPlugin = new Plugin($tmpPlugin->kPlugin);

        $nWorkingTime = $oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_workingtime'];
        $cutOffTimeTmp = explode(":",$oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_cutofftime']);
        $noDeliveryDays = explode(",",$oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_keineversandtage']);

        if (is_array($noDeliveryDays) && count($noDeliveryDays)>0) {
            foreach ($noDeliveryDays as $tmpDeliveryExclusion) {
                if (isset($dayMapping[strtoupper($tmpDeliveryExclusion)]))
                    $excludedDays[] = $dayMapping[$tmpDeliveryExclusion];
            }
        }

        // Bearbeitungszeit hinzufgen
        if ((int)$nWorkingTime>0) {
            $deliveryDate->add(new DateInterval("P" . (int)$nWorkingTime . "D"));
        }

        if (is_array($cutOffTimeTmp) && count($cutOffTimeTmp)==2) {
            // Today is deliveryday
            if (!in_array($deliveryDate->format('w'), $excludedDays)) {
                // Check cutofftime
                if ((int)$deliveryDate->format('G') > (int)$cutOffTimeTmp[0]) {
                    // Hour is after cutofftimehour --> add day
                    $deliveryDate->add(new DateInterval("P1D"));
                }
                else {
                    // Hour is not after cutofftimehour --> check if hour = cutofftomehour and check minutes
                    if ((int)$deliveryDate->format('G') ===(int)$cutOffTimeTmp[0]) {
                        // Hour = cutofftimehour and minutes are after cutofftimeminutes
                        if ((int)$deliveryDate->format('i') > (int)$cutOffTimeTmp[1]) {
                            $deliveryDate->add(new DateInterval("P1D"));
                        }
                    }
                }
            }
        }

        // is deliveryDate after adding workingtime and checking cutofftime at excluded day?
        if (in_array($deliveryDate->format('w'), $excludedDays)) {
            while(in_array($deliveryDate->format('w'), $excludedDays)) {
                $deliveryDate->add(new DateInterval("P1D"));
            }
        }

        $objResponse = new IOResponse();

        if ($startdate == null) {
            $dDate = $deliveryDate->format('Y-m-d');
        }
        else {
            $dDate = $startdate;
        }

        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandbox'] === "Y")
            $URL='https://cig.dhl.de/services/sandbox/rest/checkout/' . $zip . '/availableServices?startDate='.$dDate;
        else
            $URL='https://cig.dhl.de/services/production/rest/checkout/' . $zip . '/availableServices?startDate='.$dDate;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$URL);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandbox'] === "Y") {
            curl_setopt($ch, CURLOPT_USERPWD, $oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandboxuser'].":".$oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandboxpassword']);
        }
        else {
            curl_setopt($ch, CURLOPT_USERPWD, DHL_API_USER.":".DHL_API_PASS);
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "X-EKP: " . $oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_ekp']
        ));
        $result=curl_exec ($ch);
        $status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);   //get status code
        curl_close ($ch);

        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_debug'] == 'Y') {
            Jtllog::writeLog($oPlugin->cName . " API-Status-Code: " . $status_code, JTLLOG_LEVEL_DEBUG);
            Jtllog::writeLog($oPlugin->cName . " Result: " . $result, JTLLOG_LEVEL_DEBUG);
        }

        if ($status_code == 200) {
            $oReturn_arr = array();
            $oReturn_arr['error'] = false;
            $oReturn_arr['status_code'] = $status_code;
            $oReturn_arr['dhl_service'] = json_decode($result);
            $oReturn_arr['wunschtag_selected'] = (isset($_SESSION['wunschtag_selected']))?$_SESSION['wunschtag_selected']:"0";
            $oReturn_arr['wunschzeit_selected'] = (isset($_SESSION['wunschzeit_selected']))?$_SESSION['wunschzeit_selected']:"0";
            $objResponse->script('this.response = ' . json_encode($oReturn_arr) . ';');
            return $objResponse;
        }
        else {
            $oReturn_arr = array();
            $oReturn_arr['error'] = true;
            $oReturn_arr['status_code'] = $status_code;

            $objResponse->script('this.response = ' . json_encode($oReturn_arr) . ';');
            return $objResponse;
        }
    }


    function getAvailableDeliverySpots($address)
    {
        $tmpPlugin = Shop::DB()->selectSingleRow("tplugin", "cPluginID", "jtl_dhlwunschpaket");
        $oPlugin = new Plugin($tmpPlugin->kPlugin);

        $objResponse = new IOResponse();

        $tmpData = explode("|", $address);
        $tmpCountry = Shop::DB()->selectSingleRow("tland", "cISO", $tmpData[4]);
        $tmpAddress = urlencode($tmpData[0]." ".$tmpData[1]." ".$tmpData[2]." ".$tmpData[3]." ".$tmpCountry->cEnglisch);

        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_debug'] == 'Y') {
            Jtllog::writeLog($tmpAddress, JTLLOG_LEVEL_DEBUG);
        }

        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandbox'] == "Y")
            $URL='https://cig.dhl.de/services/sandbox/rest/parcelshopfinderrest/parcellocationByAddress/'.$tmpAddress;
        else
            $URL='https://cig.dhl.de/services/production/rest/parcelshopfinderrest/parcellocationByAddress/'.$tmpAddress;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$URL);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandbox'] === "Y") {
            curl_setopt($ch, CURLOPT_USERPWD, $oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandboxuser'].":".$oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_sandboxpassword']);
        }
        else {
            curl_setopt($ch, CURLOPT_USERPWD, DHL_API_USER.":".DHL_API_PASS);
        }
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "X-EKP: " . $oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_ekp']
        ));
        $result=curl_exec ($ch);
        $status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);   //get status code
        curl_close ($ch);

        if ($oPlugin->oPluginEinstellungAssoc_arr['jtl_dhlwunschpaket_debug'] == 'Y') {
            Jtllog::writeLog($oPlugin->cName . " API-Status-Code: " . $status_code, JTLLOG_LEVEL_DEBUG);
            Jtllog::writeLog($oPlugin->cName . " Result: " . $result, JTLLOG_LEVEL_DEBUG);
        }

        if ($status_code == 200) {
            $nFiliCount= 0;
            $nPackCount = 0;

            $locations = json_decode($result);

            foreach ($locations->psfParcellocationList as $location) {
                if (in_array("parcelpickup", $location->psfServicetypes)) {
                    if ($location->keyWord == "Postfiliale") {
                        $nFiliCount++;
                    }

                    if ($location->keyWord == "DHL Packstation") {
                        $nPackCount++;
                    }
                }
            }

            Shop::Smarty()->assign('jtl_wp_oPlugin', $oPlugin);
            Shop::Smarty()->assign('nFiliCount', $nFiliCount);
            Shop::Smarty()->assign('nPackCount', $nPackCount);
            Shop::Smarty()->assign('locations', $locations->psfParcellocationList);
            Shop::Smarty()->assign('type', $tmpData[5]);

            $return_arr['error'] = false;
            $return_arr['status_code'] = $status_code;
            $return_arr['locations'] = $locations;
            $return_arr['nFiliCount'] = $nFiliCount;
            $return_arr['nPackCount'] = $nPackCount;
            if (file_exists($oPlugin->cFrontendPfad . 'template/template/dhl_location_lookup_results_custom.tpl'))
                $return_arr['content'] = Shop::Smarty()->fetch($oPlugin->cFrontendPfad.'/templates/dhl_location_lookup_results_custom.tpl');
            else
                $return_arr['content'] = Shop::Smarty()->fetch($oPlugin->cFrontendPfad.'/templates/dhl_location_lookup_results.tpl');

            $objResponse->script('this.response = ' . json_encode($return_arr) . ';');
            return $objResponse;
        }
        else {
            $oReturn_arr = array();
            $oReturn_arr['error'] = true;
            $oReturn_arr['status_code'] = $status_code;

            $objResponse->script('this.response = ' . json_encode($oReturn_arr) . ';');
            return $objResponse;
        }
    }


    function setWunschpaketValue($type, $value) {
        $objResponse = new IOResponse();

        if ($type == "wunschtag") {
            $_SESSION['wunschtag_selected'] = $value;
        }

        if ($type == "wunschzeit") {
            $_SESSION['wunschzeit_selected'] = $value;
        }

        $oReturn_arr = array();
        $oReturn_arr['success'] = true;

        $objResponse->script('this.response = ' . json_encode($oReturn_arr) . ';');
        return $objResponse;
    }


    function setWunschlocationValue($value) {
        $objResponse = new IOResponse();

        if ($value === "") {
            unset($_SESSION['wunschlocation']);
        }
        else {
            $_SESSION['wunschlocation'] = utf8_decode($value);
        }

        $oReturn_arr = array();
        $oReturn_arr['success'] = true;

        $objResponse->script('this.response = ' . json_encode($oReturn_arr) . ';');
        return $objResponse;
    }

    $io->register('getAvailableDhlServices');
    $io->register('getAvailableDeliverySpots');
    $io->register('setWunschpaketValue');
    $io->register('setWunschlocationValue');

} catch(Exception $ex) {
    Jtllog::writeLog("jtl_dhlwunschpaket: Exception bei IO Input-Registrierung (Hook 213): " . $ex->getMessage() . "(" . $ex->getCode() . ")", JTLLOG_LEVEL_ERROR);
}